;* Filename....: LSD.ASM
;* Author......: Anand Modak
;* Date........: November 10, 1987
;* Used With...: CED.EXE (public domain Command EDitor by Christopher Dunford)
;* Called by...: CEDSYN.C 
;* Preparation.: MASM LSD,LSD,LSD,LSD /MX    LINK CEDSYN LSD /DO /NOI
;* Description.: Allows user to change directory without typing full path
;============================================================================
; routine to traverse tree structure and gather a List of all SubDirectory 
; names (LSD) and their respective paths from the root and save this info as
; a string to be used with CEDSYN - see CEDSYN.C
;============================================================================
;
_TEXT	SEGMENT  BYTE PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT  WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST,	_BSS,	_DATA
	ASSUME  CS: _TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP




_TEXT	SEGMENT	

	PUBLIC	_LSD


_LSD	PROC	NEAR
	push	bp
	mov	bp, sp
	push	di
	push	si
;
; SET DTA TO _DTATAB + AN INDEX (MORE*128) TO POINT TO NEWDTATAB OR OLD DTATAB
;
start:	mov	di,_more
	mov	cl,7			; shift left 7 is multiply by 128
	shl	di,cl			; which is the size of the dta
	mov	_curdta,di
	mov	ah,1ah
	mov	dx,offset _dtatab
	add	dx,di
        int     21h
;
; CHECK FIRST BYTE OF FILENAME OFFSET IN DTA FOR CHARACTER OR NULL.
; IF DTA HAS DATA FROM A FIND FIRST - JUMP TO FIND NEXT ELSE FIND FIRST
;
recurs:	add	dx,30
	mov	si,dx
	lodsb
	or	al,al
	jz	setup
	jmp 	nextf
;
; SETUP PATH & FILESPEC - TOTALC IS THE TOTAL CHARACTER COUNT OF THE CURRENT
; PATH TO BE SEARCHED - GOTO THE LAST CHARACTER AND ADD \* TO SEARCH FOR
; ALL 8 CHAR FILES (SUBDIRS)
;
setup:	mov	si,offset _path
	add	si,_totalc
	mov	byte ptr [si],'\'
	inc	si
	mov	byte ptr [si],'*'
	inc	si
	mov	byte ptr [si],0
;
; SEARCH FOR FIRST MATCH - SETTING CX (FILE ATTR BYTE) TO 10H MEANS DOS
; RETURNS NORMAL FILES AND SUBDIRECTORY FILES - NOT ONLY SUBDIRECTORY FILES
;
findf:	mov     ah,4eh
        mov     cx,10h
        mov     dx,offset _path
        int     21h
        jc      ifmore			; no file found - jump to ifmore to see if more traversing of tree
					; structure needs to be done or if we have finished all processing.

;
; FOUND A FILE - NOW CHECK FILE ATTRIBUTE FOR SUBDIRECTORY BIT SET 
;        
chkatr: mov	si,offset _dtatab+21
	add	si,_curdta
	lodsb
	and	al,10h
	jz	nextf			; if not a subdirectory find-next-file
;
; FOUND A SUBDIRECTORY ENTRY - CHECK TO SEE IF IT IS A "." OR ".."
; FOR CURRENT AND PREVIOUS DIRECTORY - SKIP IF IT IS OTHERWISE PROCESS IT
;	
chkdot: mov	si,offset _dtatab+30
	add	si,_curdta
	lodsb
	sub	al,2eh
	jz	nextf
;
; PROCESS SUBDIRECTORY ENTRY - COUNT # CHARACTERS AND ADD TO PATH
;
got1:	mov	di,offset _path+1	; set di to point to end of current path name plus 1
	add	di,_totalc		; to keep the '\' needed between subdirectory names
        mov     cx,0			; cx will be length of subdir name
        mov     si,offset _dtatab+30 	; after counting up to first null
	add	si,_curdta
add1:	lodsb	
	or	al,al
	je	save1
	mov	[di],al			; add subdir name to end of path for 
	inc	di			; next search
	inc	cx			; increase di and cx to accnt for '\'
	jmp	add1
;
; KEEP ACCOUNT OF SUBDIRECTORY NAME LENGTHS IN THE PATH FOR TRAVERSING
; THE TREE STRUCTURE
;
save1:	inc	_more			; add one to more for each subdir found
	inc	cx
	add	_totalc,cx		; add length of subdir name to totalc
	push	_lastc			; push previous subdir name length
	mov	_lastc,cx		; save current subdir name length to lastc
	jmp	start
;
; FIND NEXT FILE
;
nextf:	mov	ah,4fh
	int	21h
	jnc	chkatr

;
; THIS IS THE END POINT DOWN A PATH, THAT IS, FIND-NEXT RETURNED NEGATIVE.
; PROCESS THIS PATH AND THEN CHECK TO SEE IF ANY MORE TO DO - IF LASTC IS
; ZERO THERE IS NO MORE TO DO.
;
ifmore: mov	si,offset _path
	mov	bx,_totalc
	sub	bx,_lastc
	inc	bx
	add	si,bx
	mov	di,offset _subdirs
	mov	dx,_subdcnt
	add	di,dx
	mov	cx,_lastc		; check lastc to see if there is any
	or	cx,cx			; more to process else exit
	jz	exit
;
; ADD THIS SUBDIRECTORY TO SUBDIRS
;
	mov	byte ptr [di],'s'
	inc	di
	mov	byte ptr [di],'y'
	inc	di
	mov	byte ptr [di],'n'
	inc	di
	mov	byte ptr [di],' '
	inc	di			
	mov	byte ptr [di],'2'
	inc	di			; add lastc to subdcnt as the last 
	add	dx,cx			; subdir name is added to subdirs e.g. "syn ws4 cd \ws4"
	dec	cx			; rep movsb moves cx bytes which is lastc less one 
	rep movsb			; to not include '\'
	mov	byte ptr [di],' '
	inc	di
	mov	byte ptr [di],'c'
	inc	di
	mov	byte ptr [di],'d'
	inc	di
	mov	byte ptr [di],' '
	inc	di
	mov	si,offset _path
	mov	cx,_totalc
	rep movsb
	mov	byte ptr [di],0ah	; add a linefeed, c language adds the
	inc	di			; carriage return in front of this linefeed
;
; RECURS: CHECKS DTA TO SEE IF IT SHOULD CONTINUE ALONG THIS PATH
; WE HAVE TO TELL IT NOT TO
;
	mov	si,offset _dtatab+30	; set first byte in filename of this dta to null   
	add	si,_curdta              ; so as not to try to find next with this dta      
	mov	byte ptr [si],0		
; 
; TAKE THE LAST SUBDIRECTORY NAME OUT OF THE SEARCH PATH NAME BY SUBTRACTING 
; THE CHAR COUNT (LASTC) FROM (TOTALC) AND POP THE PREVIOUS LASTC.
; DECREASE MORE AND JUMP TO START.
;
	mov	ax,_totalc
	add	dx,ax			; dx (subcnt) is a count of total character in
	add	dx,9			; all the subdirectories concatenated
	mov	_subdcnt,dx		; into one long string with null delimiters
	sub	ax,_lastc		; in subdirs 
	mov	_totalc,ax
	pop	_lastc
	dec	_more
	jmp	start

	
exit:   mov	ax,offset _subdirs
	pop	si
	pop 	di
	mov	sp,bp
	pop	bp
	ret
;
_LSD	ENDP
;
_TEXT	ENDS

_DATA	SEGMENT	

	PUBLIC _subdirs

        _unused	 DB	128 DUP (0)	; CEDSYN constants seems to overwrite this area
        _subdirs DB	1024 DUP (0)	; output of this routine stored here
	_dtatab	 DB 	1024 DUP (0)	; DTA table - have to save DTA of previous directory finds
	_path	 DB	128 DUP (0)	; filespec to findfirst is held here
	_subdcnt DW	0		; count of chars in subdirs
	_totalc	 DW	0		; count of characters in path
	_lastc	 DW	0		; count of characters in last subdirectory
	_curdta	 DW	0		; pointer to current DTA in DTA table
	_more	 DW	0		; count of subdirectories away from root
					; there is 1 DTA for each subdir away from root
					; and as you come back down that path back to the root
					; that DTA can be released 
					
_DATA	ENDS
	END
	
